//+------------------------------------------------------------------------------+
//|                       MTF_PriceChannel_FiboLevelsP[sw].mq4           mod. ik |
//+------------------------------------------------------------------------------+

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 RoyalBlue
#property indicator_color2 DodgerBlue
#property indicator_color3 RoyalBlue
#property indicator_color4 DodgerBlue
#property indicator_color5 RoyalBlue
#property indicator_color6 DodgerBlue
#property indicator_color7 RoyalBlue
#property indicator_color8 Green

extern int Range=5;
extern int TimeFrame=1440;
extern int Shift=0;
extern int xtShift=0;

double UpBuffer[];
double DnBuffer[];
double MdBuffer[];
double Up23.6Buffer[];
double Dn23.6Buffer[];
double Up61.8Buffer[];
double Dn61.8Buffer[];
double Price_Buffer[];

int i;  //
string PeriodName;  //  

int init()
{
string short_name;

SetIndexStyle(0,DRAW_LINE);
SetIndexBuffer(0,UpBuffer);
    if(TimeFrame==0) TimeFrame = Period();
   SetIndexShift(0,xtShift+Shift*TimeFrame/Period());
SetIndexLabel(0,"ChannelHi("+Range+"),TF"+TimeFrame+",Shft"+Shift+"");
SetIndexDrawBegin(0,0);

SetIndexStyle(1,DRAW_LINE);
SetIndexBuffer(1,Dn23.6Buffer);
 SetIndexShift(1, xtShift+Shift*TimeFrame/Period());
SetIndexLabel(1,"ChannelDn23.6("+Range+"),TF"+TimeFrame+",Shft"+Shift+"");
SetIndexDrawBegin(1,0);

SetIndexStyle(2,DRAW_LINE);
SetIndexBuffer(2,Up61.8Buffer);
 SetIndexShift(2, xtShift+Shift*TimeFrame/Period());
SetIndexLabel(2,"ChannelUp61.8("+Range+"),TF"+TimeFrame+",Shft"+Shift+"");
SetIndexDrawBegin(2,0);

SetIndexStyle(3,DRAW_LINE);
SetIndexBuffer(3,MdBuffer);
 SetIndexShift(3, xtShift+Shift*TimeFrame/Period());
SetIndexLabel(3,"MiddleChannel("+Range+"),TF"+TimeFrame+",Shft"+Shift+"");
SetIndexDrawBegin(3,0);

SetIndexStyle(4,DRAW_LINE);
SetIndexBuffer(4,Dn61.8Buffer);
 SetIndexShift(4, xtShift+Shift*TimeFrame/Period());
SetIndexLabel(4,"ChannelDn61.8("+Range+"),TF"+TimeFrame+",Shft"+Shift+"");
SetIndexDrawBegin(4,0);

SetIndexStyle(5,DRAW_LINE);
SetIndexBuffer(5,Up23.6Buffer);
 SetIndexShift(5, xtShift+Shift*TimeFrame/Period());
SetIndexLabel(5,"ChannelUp23.6("+Range+"),TF"+TimeFrame+",Shft"+Shift+"");
SetIndexDrawBegin(5,0);


SetIndexStyle(6,DRAW_LINE);
SetIndexBuffer(6,DnBuffer);
 SetIndexShift(6, xtShift+Shift*TimeFrame/Period());
SetIndexLabel(6,"ChannelLo ("+Range+"),TF"+TimeFrame+",Shft"+Shift+"");
SetIndexDrawBegin(6,0);

SetIndexStyle(7,DRAW_LINE);
SetIndexBuffer(7,Price_Buffer);
 SetIndexShift(7, 0);
SetIndexLabel(7,"PriceChannel ("+Range+"),TF"+TimeFrame+",Shft0");
SetIndexDrawBegin(7,0);

IndicatorShortName(short_name);

switch(TimeFrame) //   TimeFrame      
  {
  case 1    : TimeFrame=PERIOD_M1;  break; //   ,     
  case 5    : TimeFrame=PERIOD_M5;  break;
  case 15   : TimeFrame=PERIOD_M15; break;
  case 30   : TimeFrame=PERIOD_M30; break;
  case 60   : TimeFrame=PERIOD_H1;  break;
  case 240  : TimeFrame=PERIOD_H4;  break;
  case 1440 : TimeFrame=PERIOD_D1;  break;
  case 10080: TimeFrame=PERIOD_W1;  break;
  case 43200: TimeFrame=PERIOD_MN1; break;
  default   : TimeFrame=Period();   break;
  }

switch(TimeFrame) //   
  {
  case PERIOD_M1    : PeriodName="M1";  break;
  case PERIOD_M5    : PeriodName="M5";  break;
  case PERIOD_M15   : PeriodName="M15"; break;
  case PERIOD_M30   : PeriodName="M30"; break;
  case PERIOD_H1    : PeriodName="H1";  break;
  case PERIOD_H4    : PeriodName="H4";  break;
  case PERIOD_D1    : PeriodName="D1";  break;
  case PERIOD_W1    : PeriodName="W1";  break;
  case PERIOD_MN1   : PeriodName="MN1"; break;
  }
short_name="MTF_PriceChannel_FiboLevelsP[sw]";
return(0);
}

int start()
{
int i,limit,counted_bars=IndicatorCounted();
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<Bars;i++)
      {
DnBuffer[i]=0.0;         
UpBuffer[i]=0.0;         
MdBuffer[i]=0.0;               
Dn23.6Buffer[i]=0.0; 
Up23.6Buffer[i]=0.0; 
Dn61.8Buffer[i]=0.0; 
Up61.8Buffer[i]=0.0; 
Price_Buffer[i]=0.0;     

      }
//----
datetime TimeArray[];
double LowArray[],HighArray[];
int y=0;  //   

if (TimeFrame<Period()) //      
  {
  SetIndexDrawBegin(0,Bars);  //  
  SetIndexDrawBegin(1,Bars);
  SetIndexDrawBegin(2,Bars);
   SetIndexDrawBegin(3,Bars);
   SetIndexDrawBegin(4,Bars);
   SetIndexDrawBegin(5,Bars);
   SetIndexDrawBegin(6,Bars);
   SetIndexDrawBegin(7,Bars);
  return(0);
  }
//       
ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame);
//  Low  

  
  
  
ArrayCopySeries(LowArray,MODE_LOW,Symbol(),TimeFrame);
// High
ArrayCopySeries(HighArray,MODE_HIGH,Symbol(),TimeFrame);

for(i=0,y=0;i<Bars-counted_bars;i++)
  {
  //           , 
  //        (   )
  if (Time[i]<TimeArray[y]) y++;
  

  //|   /    ,
  DnBuffer[i]=LowArray[Lowest(NULL,TimeFrame,MODE_LOW,Range,y)];
  //|        
  UpBuffer[i]=HighArray[Highest(NULL,TimeFrame,MODE_HIGH,Range,y)];
  //|LowArray  HighArray
  MdBuffer[i]=(UpBuffer[i]+DnBuffer[i])/2;
  
      Dn23.6Buffer[i] = UpBuffer[i]-((UpBuffer[i]-DnBuffer[i])*23.6/100);
      Up23.6Buffer[i] = DnBuffer[i]+((UpBuffer[i]-DnBuffer[i])*23.6/100);
      Up61.8Buffer[i] = DnBuffer[i]+((UpBuffer[i]-DnBuffer[i])*61.8/100);
      Dn61.8Buffer[i] = UpBuffer[i]-((UpBuffer[i]-DnBuffer[i])*61.8/100);
  


  }

 i=Bars-1;

 if(counted_bars>1) i=Bars-counted_bars-1;
   while(i>=0) { Price_Buffer[i]=Close[i]; i--; }

return(0);
}

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   Comment("");
//----
   return(0);
  }

